/* ptprops.p
 *
 * properties controlled by os-getenv variables
 *
 */

{lib/protop.i}

define new global shared variable custId     as character no-undo.
define new global shared variable pt_backend as character no-undo.		/* pt3 portal server				*/
define new global shared variable portalProxy   as character no-undo.		/* proxy server					*/
define new global shared variable pt_dlcmd   as character no-undo.		/* auto download command			*/

session:add-super-procedure( this-procedure ).

subscribe to "protop_properties" anywhere run-procedure "ptproperties".

return.


procedure ptproperties:

  define variable pp as character no-undo.

  pp = replace( propath, ",", " " ).                  /* spaces make word breaks      */

  display
    skip(1)
    "  PROPATH:" pp view-as editor size 90 by 7
    skip(1)		/* not updateable!	*/
    "                     custId:" custId               format "x(20)"                "  Server:" at 55 pt_server  format "x(40)"     skip
    "              Friendly Name:" pt_shortname         format "x(20)"                "  Portal:" at 55 pt_backend format "x(40)"     skip
    "             Resource Group:" pt_resrcType         format "x(20)"                "   Proxy:" at 55 portalProxy   format "x(40)"     skip
    "         Auto Update Method:" pt_dlcmd             format "x(20)"                "  TMPDIR:" at 55 pt_tmpdir  format "x(40)"     skip
    "                Unique File:" pt_uniqName          format "x(20)"                "  LOGDIR:" at 55 pt_logdir  format "x(40)"     skip
    "            Lock Scan Limit:" pt_lktbllim          format "->>,>>>,>>9" to 45    "  RPTDIR:" at 55 pt_rptdir  format "x(40)"     skip
    skip(1)
    "                              *** Alerts only apply to paid portal customers ***  " skip		/* shown for information / debugging reasons	*/
    skip(1)
    "              DBI Downgrade:" pt_DBIDowngrade      format "yes/no"      to 45 "  (Do not alert if an error involves the DBI file)  " skip
    skip(1)
    "                Backup Info:" pt_bkupInfo          format "->>,>>>,>>9" to 45  "             BI Backup Info:" pt_bibkupInfo        format "->>,>>>,>>9" to 95 skip
    "               Backup Alert:" pt_bkupAlert         format "->>,>>>,>>9" to 45  "            BI Backup Alert:" pt_bibkupAlert       format "->>,>>>,>>9" to 95 skip
    "               Backup Alarm:" pt_bkupAlarm         format "->>,>>>,>>9" to 45  "            BI Backup Alarm:" pt_bibkupAlarm       format "->>,>>>,>>9" to 95 skip
    "                Backup Page:" pt_bkupPage          format "->>,>>>,>>9" to 45  "             BI Backup Page:" pt_bibkupPage        format "->>,>>>,>>9" to 95 skip
    skip(1)
    "           Quiet Point Info:" pt_qpInfo            format "->>,>>>,>>9" to 45  "        Long AI Switch Info:" pt_aiswInfo          format "->>,>>>,>>9" to 95 skip
    "          Quiet Point Alert:" pt_qpAlert           format "->>,>>>,>>9" to 45  "       Long AI Switch Alert:" pt_aiswAlert         format "->>,>>>,>>9" to 95 skip
    "          Quiet Point Alarm:" pt_qpAlarm           format "->>,>>>,>>9" to 45  "       Long AI Switch Alarm:" pt_aiswAlarm         format "->>,>>>,>>9" to 95 skip
    "           Quiet Point Page:" pt_qpPage            format "->>,>>>,>>9" to 45  "        Long AI Switch Page:" pt_aiswPage          format "->>,>>>,>>9" to 95 skip

    skip(2)		/* updateable vvv	*/

    "                Debug Level:" dbgMode              format           "9" to 45 skip
    "           Very Old TRX Age:" pt_votrx             format "->>,>>>,>>9" to 45 skip
    "        BogoMIPS Iterations:" pt_bogomips          format "->>,>>>,>>9" to 45 skip
    "         IO Response Probes:" pt_ioresp            format "->>,>>>,>>9" to 45 skip
    "          AI Check Interval:" pt_AICheckInterval   format "->>,>>>,>>9" to 45 skip
    "        PICA Check Interval:" pt_PICACheckInterval format "->>,>>>,>>9" to 45 skip
    "           Appsrv Stuck Age:" pt_appsrvStuck       format "->>,>>>,>>9" to 45 skip
    "                 Top X Rows:" rowLimit             format "->>,>>>,>>9" to 45 skip
    "       Enable UserLock Data:" pt_userLock          format "yes/no"      to 45 "  (11.7+, may be very slow with large -L or user count) " skip
    "     Enable User Experience:" pt_doZippy           format "yes/no"      to 45 '  (aka "zippy")  '                                        skip
    " Allow rfutil for AI status:" pt_useRFUtil         format "yes/no"      to 45 "  (needed prior to 11.7, not used from 11.7 on) "         skip
    skip(1)
    '           ProTop Help Link:' pt_helplink          format "x(60)"     skip
    '      ProTop Community Link:' pt_commlink          format "x(60)"     skip
    '               "df" Command:' pt_dfCmd             format "x(60)"     skip
    '        inodes "df" Command:' pt_dfCmdI            format "x(60)"     skip
    '            "mount" Command:' pt_mntCmd            format "x(60)"     skip
    '             "mail" Command:' pt_mailcmd           format "x(60)"     skip
    "      IO Response File List:" pt_ioFileName        format "x(60)"     skip
    skip(1)
   with
    frame getProps
    title " ProTop Properties "
    row 3
    column 28
    width 106
    no-labels
    overlay
  .

  do on error undo, leave
    on endkey undo, leave:

    update

      dbgMode
      pt_votrx
      pt_bogomips
      pt_ioresp
      pt_AICheckInterval
      pt_PICACheckInterval
      pt_appsrvStuck
      rowLimit
      pt_userLock
      pt_doZippy
      pt_useRFUtil

      pt_helplink
      pt_commlink
      pt_dfCmd
      pt_dfCmdI
      pt_mntCmd
      pt_mailCmd
      pt_ioFileName

     with
      frame getProps
    .

  end.

  hide frame getProps.

  return.

end.
